/*
 *		Copyright (C) 2013, 2014, 2015 by the Konclude Developer Team.
 *
 *		This file is part of the reasoning system Konclude.
 *		For details and support, see <http://konclude.com/>.
 *
 *		Konclude is free software: you can redistribute it and/or modify it under
 *		the terms of version 2.1 of the GNU Lesser General Public License (LGPL2.1)
 *		as published by the Free Software Foundation.
 *
 *		You should have received a copy of the GNU Lesser General Public License
 *		along with Konclude. If not, see <http://www.gnu.org/licenses/>.
 *
 *		Konclude is distributed in the hope that it will be useful,
 *		but WITHOUT ANY WARRANTY; without even the implied warranty of
 *		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. For more
 *		details, see GNU Lesser General Public License.
 *
 */

#ifndef KONCLUDE_NETWORK_HTTP_CQTHTTPRESPONSE_H
#define KONCLUDE_NETWORK_HTTP_CQTHTTPRESPONSE_H

// Namespace includes
#include "HttpSettings.h"
#include "CHttpResponse.h"
#include "CQtHttpRequest.h"

// Library includes
#include <QNetworkReply>

// Other includes
#include "Network/CNetworkResponse.h"

#include "Concurrent/Callback/CCallbackData.h"
#include "Concurrent/Callback/CCallbackRememberLinkedExecuter.h"

// Logger includes
#include "Logger/CLogger.h"


namespace Konclude {

	using namespace Concurrent::Callback;

	namespace Network {

		namespace HTTP {


			/*! 
			*
			*		\class		CQtHttpResponse
			*		\author		Andreas Steigmiller
			*		\version	0.1
			*		\brief		TODO
			*
			*/
			class CQtHttpResponse : public CHttpResponse {
				// public methods
				public:
					//! Constructor
					CQtHttpResponse(CQtHttpRequest* request, QNetworkReply* qNetworkReply = nullptr);

					//! Destructor
					virtual ~CQtHttpResponse();

					QNetworkReply* getQNetworkReply();
					CQtHttpRequest* getHttpRequest();
					CQtHttpResponse* setQNetworkReply(QNetworkReply* qNetworkReply);

					CCallbackRememberLinkedExecuter* getFinishedCallbackList();


				// protected methods
				protected:

				// protected variables
				protected:
					QNetworkReply* mQNetworkReply;
					CCallbackRememberLinkedExecuter finishCallbackList;
					CQtHttpRequest* mRequest;

				// private methods
				private:

				// private variables
				private:
			};


		}; // end namespace HTTP

	}; // end namespace Network

}; // end namespace Konclude


#endif // KONCLUDE_NETWORK_HTTP_CQTHTTPRESPONSE_H
