/*
 *		Copyright (C) 2013, 2014, 2015 by the Konclude Developer Team.
 *
 *		This file is part of the reasoning system Konclude.
 *		For details and support, see <http://konclude.com/>.
 *
 *		Konclude is free software: you can redistribute it and/or modify it under
 *		the terms of version 2.1 of the GNU Lesser General Public License (LGPL2.1)
 *		as published by the Free Software Foundation.
 *
 *		You should have received a copy of the GNU Lesser General Public License
 *		along with Konclude. If not, see <http://www.gnu.org/licenses/>.
 *
 *		Konclude is distributed in the hope that it will be useful,
 *		but WITHOUT ANY WARRANTY; without even the implied warranty of
 *		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. For more
 *		details, see GNU Lesser General Public License.
 *
 */

#ifndef KONCLUDE_REASONER_KERNEL_PROCESS_CBLOCKINGALTERNATIVESIGNATUREBLOCKINGCANDIDATEDATA_H
#define KONCLUDE_REASONER_KERNEL_PROCESS_CBLOCKINGALTERNATIVESIGNATUREBLOCKINGCANDIDATEDATA_H

// Libraries includes


// Namespace includes
#include "ProcessSettings.h"
#include "CBlockingAlternativeData.h"
#include "CIndividualProcessNode.h"


// Other includes



// Logger includes
#include "Logger/CLogger.h"



namespace Konclude {

	namespace Reasoner {

		namespace Kernel {

			namespace Process {

				/*! 
				 *
				 *		\class		CBlockingAlternativeSignatureBlockingCandidateData
				 *		\author		Andreas Steigmiller
				 *		\version	0.1
				 *		\brief		TODO
				 *
				 */
				class CBlockingAlternativeSignatureBlockingCandidateData : public CBlockingAlternativeData {
					// public methods
					public:
						//! Constructor
						CBlockingAlternativeSignatureBlockingCandidateData();


						CBlockingAlternativeSignatureBlockingCandidateData* initSignatureBlockingCandidateData(CIndividualProcessNode* blockIndiCand, cint64 violatedResCount, cint64 violatedNonDetResCount, cint64 diffConceptCount);
						CIndividualProcessNode* getSignatureBlockingCandidateNode();
						CBlockingAlternativeSignatureBlockingCandidateData* setSignatureBlockingCandidateNode(CIndividualProcessNode* blockIndiCan);

						cint64 getConceptDifferenceCount();
						cint64 getViolatedRestrictionCount();
						cint64 getViolatedNonDeterministicRestrictionCount();

						CBlockingAlternativeSignatureBlockingCandidateData* setConceptDifferenceCount(cint64 count);
						CBlockingAlternativeSignatureBlockingCandidateData* setViolatedRestrictionCount(cint64 count);
						CBlockingAlternativeSignatureBlockingCandidateData* setViolatedNonDeterministicRestrictionCount(cint64 count);


						virtual BLOCKINGALTERNATIVEDATA getBlockingAlternativeDataType();


					// protected methods
					protected:

					// protected variables
					protected:
						CIndividualProcessNode* mBlockIndiCandi;
						cint64 mViolatedResCount;
						cint64 mViolatedNonDetResCount;
						cint64 mDiffConceptCount;

					// private methods
					private:

					// private variables
					private:

				};

			}; // end namespace Process

		}; // end namespace Kernel

	}; // end namespace Reasoner

}; // end namespace Konclude

#endif // KONCLUDE_REASONER_KERNEL_PROCESS_CBLOCKINGALTERNATIVESIGNATUREBLOCKINGCANDIDATEDATA_H
